require('../lib/augment');
var assert = require('assert');

'use strict;';

var Animal = Object.augment({
	constructor: function() { 
		console.log('Animal constructor.');
		return this;
	},
	getType: function() {
		return 'Animal';
	},
	getNoise: function() {
		console.log('Not implemented');
		return this;
	}
});

var Dog = Animal.augment({
	constructor: function() {
		Animal.call(this);
		console.log('Dog constructor.');
		return this;
	},
	getType: function() {
		return 'Dog';
	},
	getNoise: function() {
		return 'Ouaf!';
	}
});

/**
 * Entry point.
 */
var main = function() {
	var dog = new Dog();
	assert.equal(dog.getType(), 'Dog');
	assert.equal(dog.getNoise(), 'Ouaf!');

	var animal = new Animal();
	assert.equal(animal.getType(), 'Animal');
};
	
if (require.main === module) {
    main();
}